//----------------------------------------------------------------------------------
// File:            apps\lorenz\assets\lorenz.vert
// Samples Version: Android NVIDIA samples 0.1 
// Email:           tegradev@nvidia.com
// Forum:           http://developer.nvidia.com/tegra/forums/tegra-forums/android-development
//
// Copyright 2009-2010 NVIDIA Corporation 
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
//----------------------------------------------------------------------------------
// does a 4x4 matrix transform on position

// constants:
uniform mat4 mvp; // model-view-projection matrix.
uniform vec3 eye_position;
uniform vec3 light_direction;

// inputs:
attribute vec3 input_position;
attribute vec3 input_normal;

// outputs:
// gl_Position (implicit)
varying vec4 varying_color;

void main() {
	gl_Position = mvp * vec4(
		input_position.x,
		input_position.y,
		input_position.z,
		1
	);
	float d = dot(input_normal,light_direction);
	varying_color = vec4(d, d, d, 1);

	//vec3 ld_temp = vec3(0, -1, 0);
	////float d = dot(input_normal,ld_temp);
	//float d = input_normal.x * ld_temp.x + input_normal.y * ld_temp.y + input_normal.z * ld_temp.z;
	//varying_color = vec4(d, d, d, 1);

	//varying_color = vec4(light_direction.x, light_direction.y, light_direction.z, 1);

	//vec3 ld_temp = vec3(0, 1, 0); //-1 would give black color
	//varying_color = vec4(ld_temp.x, ld_temp.y, ld_temp.z, 1);

	//vec3 n = input_normal/2.0+0.5;
	//vec3 n = input_normal/20.0+0.5;
    	//varying_color = vec4(n.x, n.y, n.z, 1);

    	//varying_color = vec4(1, 1, 1, 1);
}
